﻿/*
                BS_Ørganiz_Øutils
                
    ***** Ce script est un outil multitaches dédié à l'organisation de son travail dans After Effects. *****
    
    J'y ai ajouté différentes fonctions afin d'optimiser le process et rendre l'utilisation du script la plus intuitive et la plus effective possible.
    
    Seulement pour Windows.
    Seulement pour les versions d'After Effects installées en FRANçAIS: fr_FR ou en ANGLAIS: en_EN.
    Optimisé pour After Effect CC est supérieure.
    
    Développé sous Windows 7 Pro (fr).
    
    Testé avec les versions After Effects (fr)(en):
        _  11 (CS6) --------------------- non
        _ 13 (CC2014) --------------------- non
        _ 13.5 + maj (CC2015) --------------------- non
        _ 14 (CC2017) --------------------- non
        _ 14.2.1.34 (CC2017)
        
    Version 1.1:
        _ Dernière mise à jour : 25/10/2017
            _ Traduction pour les versions en_US d'After Effects.
            _ Remplacement du callback onChange par onEnterKey des fonctions renommage qui causait des soucis pour les versions en_US.
        
Par Simon Salord
(BS pour Black Solid)

J'espère que ce script vous sera autant utile qu'il l'est pour moi!
*/
{
function KeepOrganiz_PMTools (thisObj){
    
// ------------------------------------------------ variables globales ------------------------------------------------- //
    var scriptName = "BS_Ørganiz_Øutils";
    var scriptVersion = "_v1";

    var thisScriptPath = File ($.fileName).path;
    thisScriptPath_parent = Folder (thisScriptPath);
    pathToCheck = thisScriptPath_parent.path+"/Startup";
    localize_KO = File (pathToCheck+"/BS_Ørganiz_v2.jsx");
    var AE_folderIcon = File (thisScriptPath_parent.parent.path+"/PNG/SP_Folder_Lg_N_D.png");
    
// globals pour la trad
    var organiz_Tools_GlobalsDatas = new Object();
    organiz_Tools_GlobalsDatas.lang = app.isoLanguage.split("_")[0];
    organiz_Tools_GlobalsDatas.InfoMsg_str = {
        fr: scriptName+scriptVersion+"\n"+
        "Par Simon Salord\n"+
        "http://nowisvalvert.wix.com/simonsalord\n"+
        "\n\n"+
        "Ø :   Execute \"BS_Ørganiz_v2.jsx\" si celui-ci est disponible.\n"+
        "\n"+
        "▲ :   Ouvre la fenêtre Projet si celle-ci est fermée ou inactive.\n"+
        "└› (Ctrl+clic) Retrouve les calques séléctionnés dans la composition active et les affiche dans la fenêtre Projet.\n"+
        "└› (Alt+clic) Permet l'expansion de tous les dossiers de la fenêtre Projet.\n"+
        "\n"+
        "(icone dossier)(+) :   (Si une séléction est faite dans la fenêtre Projet)\nPermet de créer un nouveau dossier parent pour la séléction.\n"+
        "\n\n"+
        "ØrganiZer-séléction :   Permet de ranger les calques séléctionnés dans la composition active via la vue schématique projet par un double clique sur le nom de dossier.\n"+
        "\n"+
        "CØMP :   Ouvre la fenêtre de création de composition classique d'After Effects.\nLorsque la nouvelle composition est validée, celle-ci peut être rangée via la vue schématique projet par un double clique sur le nom de dossier.\n"+
        "\n"+
        "P-CØMP :   Ouvre la fenêtre de précomposition classique d'After Effects.\nLorsque la précomposition est validée, celle-ci peut être rangée via la vue schématique projet par un double clique sur le nom de dossier.\n"+
        "\n\n"+
        "\"renommer séléction\" :   (Valider avec Entrée ou  Entr)\nPermet de renommer le/les calque(s) séléctionné(s).\n"+
        "Si plusieurs calques sont séléctionnés, le nom sera automatiquement incrémenté en respectant l'ordre de la séléction.\nTerminer la saisie du nom par un point \".\" permet d'annuler l'incrémentation.\n"+
        "\n"+
        "\"préfixe\" :   (Valider avec Entrée ou  Entr)\nPermet d'ajouter un préfixe en préservant le nom du/des calque(s) séléctionné(s).\nCommencer la saisie par \"#\" permet une incrémentation avant le nom en préservant le texte entré pour le préfixe.\n"+
        "\n"+
        "\"suffixe\" :   (Valider avec Entrée ou  Entr)\nPermet d'ajouter un suffixe en préservant le nom du/des calque(s) séléctionné(s).\nTerminer la saisie par \"#\" permet une incrémentation après le nom en préservant le texte entré pour le suffixe.\n",
        en: scriptName+scriptVersion+"\n"+
        "By Simon Salord\n"+
        "http://nowisvalvert.wix.com/simonsalord\n"+
        "\n\n"+
        "Ø :   Execute \"BS_Ørganiz_v2.jsx\" if it is available.\n"+
        "\n"+
        "▲ :   Open the Project panel if it is closed or inactive.\n"+
        "└› (Ctrl+clic) Find the layers selected in the active composition and display them in the Project panel.\n"+
        "└› (Alt+clic) Allows the expansion of all folders in the Project Panel.\n"+
        "\n"+
        "(icon folder)(+) :   (If a selection is made in the Project panel)\nAllows to create a new parent folder for the selection.\n"+
        "\n\n"+
        "ØrganiZ-selection :   Stores the layers selected in the active composition through the schematic project view by double clicking on the folder name.\n"+
        "\n"+
        "CØMP :   Opens the classic After Effects composition creation window. \nWhen the new composition is validated, it can be sorted through the schematic project view by double clicking on the folder name.\n"+
        "\n"+
        "P-CØMP :   Opens the classic After Effects precomposition window. \nWhen the precomposition is validated, it can be sorted via the schematic project view by double clicking on the folder name.\n"+
        "\n\n"+
        "\"rename selection\" :   (Press Enter to validate)\nRename the selected layer(s).\n"+
        "If multiple layers are selected, the name will be automatically incremented according to the order of the selection. \nComplete the entry of the name with a dot \".\" to ignore the incrementation.\n"+
        "\n"+
        "\"prefix\" :   (Press Enter to validate)\nAdds a prefix preserving the name of the selected layer(s). \nStarting entry with \"#\" allows you to increment before the name preserving the text entered for the prefix.\n"+
        "\n"+
        "\"suffix\" :   (Press Enter to validate)\nAllows you to add a suffix by preserving the name of the selected layer(s). \nComplete entry with \"#\" allows you to increment after the name preserving the text entered for the suffix.\n"
    };
    organiz_Tools_GlobalsDatas.rangerBut_str = {
        fr: "ØrganiZer-séléction",
        en: "ØrganiZ-selection"
    };
    organiz_Tools_GlobalsDatas.renameLay_str = {
        fr: "\"renommer séléction\"",
        en: "\"rename selection\""
    };
    organiz_Tools_GlobalsDatas.addPrefixe_str = {
        fr: "\"préfixe\"",
        en: "\"prefix\""
    };
    organiz_Tools_GlobalsDatas.addSuffix_str = {
        fr: "\"suffixe\"",
        en: "\"suffix\""
    };
    organiz_Tools_GlobalsDatas.treeCloseBut_str = {
        fr: "Annuler",
        en: "Cancel"
    };
    organiz_Tools_GlobalsDatas.nf_winTitle_str = {
        fr: "Nom du nouveau dossier:",
        en: "Name of the new folder:"
    };

// --------------------------------- fonction pour traduire en fonction de la langue d'After --------------- //
    function OrganTools_Trad (TXT_str)
    {
        var currStr = TXT_str[organiz_Tools_GlobalsDatas.lang];
        if (currStr == undefined) currStr = TXT_str["en"];
        return currStr;
    }

    var infoMsg_str = OrganTools_Trad (organiz_Tools_GlobalsDatas.InfoMsg_str);

// ------------------------------------------------------------------------------- Main UI ----------------------------------------------------------------------------- //

    var PMT_win = (thisObj instanceof Panel) ? thisObj : new Window("palette",scriptName+scriptVersion, undefined, {resizeable:true});
    PMT_win.alignChildren = ['fill','center'];
    PMT_win.orientation = 'row';
    PMT_win.margins = 0;
    PMT_win.spacing = 2;
    
    var PMT_grp1 = PMT_win.add("panel");
    PMT_grp1.orientation = 'column';
    PMT_grp1.alignChildren = 'center';
    PMT_grp1.alignment = ['left', 'center'];
    PMT_grp1.margins = 2;
    PMT_grp1.spacing = 2;
        var PMT_grp1sgp1 = PMT_grp1.add("group");
        PMT_grp1sgp1.margins = 0;
        PMT_grp1sgp1.spacing = 5;
        var PMT_ExecutKO_but = PMT_grp1sgp1.add("button", undefined, "Ø");
        var PMT_openProjpan_but = PMT_grp1sgp1.add("button", undefined, "▲");
        PMT_ExecutKO_but.size = PMT_openProjpan_but.size = [18,18];
        
        var PMT_grp1sgp2 = PMT_grp1.add("group");
        PMT_grp1sgp2.margins = 0;
        PMT_grp1sgp2.spacing = 6;
        var PMT_info_but = PMT_grp1sgp2.add("button", undefined, "?");
            var PMT_grp1sgp3 = PMT_grp1sgp2.add("group");
            PMT_grp1sgp3.margins = 0;
            PMT_grp1sgp3.orientation = 'stack';
            //tempPath = "/c/Program Files/Adobe/Adobe After Effects CC 2017/Support Files/PNG/SP_Folder_Lg_N_D.png";
            var PMT_temp02_but = (AE_folderIcon.exists) ? PMT_grp1sgp3.add("iconbutton", undefined, AE_folderIcon) : PMT_grp1sgp3.add("button", undefined, "");
            PMT_temp02_but.onDraw = function (){var plouf; (AE_folderIcon.exists) ? PMT_temp02_but.graphics.drawImage (ScriptUI.newImage(AE_folderIcon), 0, 0, 18, 18) : plouf;}
            var PMT_nItemFolderTxt_but = PMT_grp1sgp3.add("statictext", undefined, "+");
            if (AE_folderIcon.exists) PMT_nItemFolderTxt_but.graphics.foregroundColor = PMT_nItemFolderTxt_but.graphics.newPen(PMT_nItemFolderTxt_but.graphics.PenType.SOLID_COLOR, [0.2,0.2,0.2], 1);
        PMT_info_but.size = PMT_temp02_but.size = [18,18];
        //PMT_temp02_but.visible = false;
    
    var PMT_grp2 = PMT_win.add("panel");
    PMT_grp2.alignChildren = 'center';
    PMT_grp2.alignment = ['center','center'];
    PMT_grp2.margins = 2;
    PMT_grp2.spacing = 2;
        var PMT_Ranger_but = PMT_grp2.add("button", undefined, OrganTools_Trad (organiz_Tools_GlobalsDatas.rangerBut_str));
        PMT_Ranger_but.size = [105, 20];
        var PMT_grp2sgp = PMT_grp2.add("group");
        PMT_grp2sgp.margins = [0,0,0,0];
        PMT_grp2sgp.spacing = 5;
            var PMT_newComp_but = PMT_grp2sgp.add("button", undefined, "CØMP");
            var PMT_preComp_but = PMT_grp2sgp.add("button", undefined, "P-CØMP");
            PMT_newComp_but.size = PMT_preComp_but.size = [50,18];
        
    var PMT_grp3 = PMT_win.add("panel");
    PMT_grp3.orientation = 'column';
    PMT_grp3.alignChildren = 'center';
    PMT_grp3.alignment = ['right','center'];
    PMT_grp3.margins = 2;
    PMT_grp3.spacing = 2;
    
    var PMT_renameLayers_Txt = OrganTools_Trad (organiz_Tools_GlobalsDatas.renameLay_str);
    var PMT_addPrefix_Txt = OrganTools_Trad (organiz_Tools_GlobalsDatas.addPrefixe_str);
    var PMT_addSuffix_Txt = OrganTools_Trad (organiz_Tools_GlobalsDatas.addSuffix_str);
        var PMT_renameLayers_edtx = PMT_grp3.add("edittext", undefined, PMT_renameLayers_Txt, {enterKeySignalsOnChange: true});
        PMT_renameLayers_edtx.size = [115,20];
        var PMT_grp3sgp = PMT_grp3.add("group");
        PMT_grp3sgp.orientation = 'row';
        PMT_grp3sgp.margins = [0,0,0,0];
        PMT_grp3sgp.spacing = 8;
            var PMT_addPrefix_edtx = PMT_grp3sgp.add("edittext", undefined, PMT_addPrefix_Txt, {enterKeySignalsOnChange: true});
            PMT_addPrefix_edtx.size = [52.5,20];
            var PMT_addSuffix_edtx = PMT_grp3sgp.add("edittext", undefined, PMT_addSuffix_Txt, {enterKeySignalsOnChange: true});
            PMT_addSuffix_edtx.size = [52.5,20];
        
    
    PMT_win.layout.layout(true);
    PMT_win.layout.resize();
    PMT_win.onResizing = PMT_win.onResize = function () { this.layout.resize(); }
    if (!(thisObj instanceof Panel)) PMT_win.show();
    
// --------------------------------------------------------------------------------------  construir la fenêtre schematique Projet ----------------------------------------------- //
function buildSchematicView_project ()
{
    var ScV_Proj = new Window ("palette", undefined, undefined, {closeButton: false, borderless: true});
    ScV_Proj.margins = 2;
    return ScV_Proj;
}

var SchematicView = buildSchematicView_project ();
var ScV_Tree = SchematicView.add("treeview");
ScV_Tree.size = [200,450];
var ScV_Tree_closeBut = SchematicView.add("button", undefined, OrganTools_Trad (organiz_Tools_GlobalsDatas.treeCloseBut_str));
ScV_Tree_closeBut.onClick = function(){
    ScV_Tree.removeAll();
    SchematicView.hide();
    };  

// ------------------------------------------------------------------------------------------- fenêtre pour nommer le nouveau dossier ----------------------------------- //
function nameNewFolder ()
{
    var nf_win = new Window("dialog",OrganTools_Trad (organiz_Tools_GlobalsDatas.nf_winTitle_str));
    nf_win.orientation = 'row';
    nf_win.spacing = 2;
    var nf_txt = nf_win.add("edittext", undefined, "");
    nf_txt.characters = 20;
    var nf_ok_but = nf_win.add("button", undefined, "OK");
    var nf_no_but = nf_win.add("button", undefined, "Cancel");
    nf_ok_but.size = nf_no_but.size = [42,22];
    
    var name_txt;
    if (nf_win.show() == 1)
    {
        name_txt = nf_txt.text;
    }
return name_txt;
}
        
// ------------------------------------------------------------------- Manager l'UI --------------------------------------- //
if (!localize_KO.exists)
{
    PMT_ExecutKO_but.enabled = false;
} else {
    PMT_ExecutKO_but.enabled = true;
}

PMT_renameLayers_edtx.enabled = PMT_addPrefix_edtx.enabled = PMT_addSuffix_edtx.enabled = false;
PMT_renameLayers_edtx.onActivate =  PMT_addPrefix_edtx.onActivate = PMT_addSuffix_edtx.onActivate = function ()
    {
        this.text = "";
    };

PMT_renameLayers_edtx.onDeactivate =  PMT_addPrefix_edtx.onDeactivate = PMT_addSuffix_edtx.onDeactivate = function ()
    {
        if (this == PMT_renameLayers_edtx) PMT_renameLayers_edtx.text = PMT_renameLayers_Txt;
        if (this == PMT_addPrefix_edtx) PMT_addPrefix_edtx.text = PMT_addPrefix_Txt;
        if (this == PMT_addSuffix_edtx) PMT_addSuffix_edtx.text = PMT_addSuffix_Txt;
       // PMT_win.update();
    };

PMT_win.addEventListener("mouseover", function ()
    {
        var Comp = app.project.activeItem;
        if ( !Comp|| !(Comp instanceof CompItem) ) return;
        if (!Comp.selectedLayers.length)
        {
            PMT_renameLayers_edtx.enabled = PMT_addPrefix_edtx.enabled = PMT_addSuffix_edtx.enabled  = false;
        } else {
            PMT_renameLayers_edtx.enabled = PMT_addPrefix_edtx.enabled = PMT_addSuffix_edtx.enabled  = true;
        }
    });
// ---------------------------------------------- fonctions ---------------------------------------------------------- //
    function execute_KO ()
    {
        if (localize_KO.exists)
        {
            localize_KO.open("r");
            eval(localize_KO.read());
            localize_KO.close();
        } else {
            PMT_ExecutKO_but.enabled = false;
            return;
        }
    }

    function showProjPan ()
    {
        var CTRL = ctrlState ();
        var ALT = altState ();
        if (CTRL == 1)
        {
            var Comp = app.project.activeItem;
            if (!Comp || (!Comp instanceof CompItem)) return;
            if (Comp.selectedLayers.length>0)
            {
                for (l = 0; l<Comp.selectedLayers.length; l++)
                {
                    curLayer = Comp.selectedLayers[l];
                    if ( (curLayer instanceof CameraLayer) || (curLayer instanceof LightLayer) || (curLayer instanceof ShapeLayer) || (curLayer instanceof TextLayer) ) continue;
                    for (i=1; i<=app.project.numItems; i++)
                    {
                        curItem = app.project.items[i];
                        if (curItem instanceof FolderItem) continue;
                        if (curLayer.source.name == curItem.name) curItem.selected = true;
                    }
                }
            }
        }
    
        if (ALT == 1)
        {
            for (i = 1; i<=app.project.numItems; i++){app.project.items[i].selected = false};
        }
        app.project.showWindow(true);
    }
  
    function oRganiz ()
    {
        var Comp = app.project.activeItem;
        if (!Comp || (!(Comp instanceof CompItem)) || (!(Comp.selectedLayers.length)) ) return;
        ProjectSchematicView ("win_center");
        ScV_Tree.onDoubleClick = function organiz_layer ()
        {
            if (ScV_Tree.selection != null)
           {
               for (l=0; l<Comp.selectedLayers.length; l++)
               {
                   setParentFolder (Comp.selectedLayers[l], "Calque");
               }
           } else return;
       SchematicView.hide();
       ScV_Tree.removeAll();
        }
    }

    function OrganizWithNewFolder ()
    {
        var Projet = app.project;
        var isSel = isItemSel ();
        if (isSel)
        {
            app.beginUndoGroup("[ØuTils] Nouveau dossier")
            cn_folderName = nameNewFolder ();
            if ((cn_folderName == undefined)||(cn_folderName == null)) return;
            cn_folder = Projet.items.addFolder(cn_folderName);
            for (S=1; S<=Projet.numItems; S++)
            {
                if (Projet.items[S].selected) Projet.items[S].parentFolder = cn_folder;
            }
            for (S=1; S<=Projet.numItems; S++)
            {
                if (Projet.items[S].name == cn_folderName) Projet.items[S].selected = true;
            }
            app.endUndoGroup();
        } else { return; }
    }

    function newCompAndOrganiz ()
    {
     app.beginUndoGroup("[ØuTils] Nouv-Comp");
        ProjNumItems_before = app.project.numItems;
        var nComp_str = (app.isoLanguage == "fr_FR") ? "Nouvelle composition..." : "New Composition...";
        var nCompID = app.findMenuCommandId(nComp_str);
        app.executeCommand(nCompID);
        ProjNumItems_after = app.project.numItems;
        if (ProjNumItems_after == ProjNumItems_before)
        {
            return;
        } else {
            ProjectSchematicView ();
            ScV_Tree.onDoubleClick = function m_Comp ()
            {
                if (ScV_Tree.selection != null)
                {
                    for (i=1; i<=app.project.numItems; i++)
                    {
                        if (app.project.items[i].name == app.project.activeItem.name)
                        {
                            MyNewComp = app.project.items[i];
                            setParentFolder (MyNewComp, "Compo");
                            break;
                        }
                    }
                }
            SchematicView.hide();
            ScV_Tree.removeAll();
            }
        }
    app.endUndoGroup();
    }
    
    function pCompAndOrganiz ()
    {
     app.beginUndoGroup("[ØuTils] Pré-Comp");
        var Comp = app.project.activeItem;
        if (!Comp || !(Comp instanceof CompItem)) return;
        ProjNumItems_before = app.project.numItems;
        var activeComp_before = app.project.activeItem.name;
        var pComp_str = (app.isoLanguage == "fr_FR") ? "Précomposition..." : "Pre-compose...";
        var pCompID = app.findMenuCommandId(pComp_str);
        app.executeCommand(pCompID);
        ProjNumItems_after = app.project.numItems;
        if (ProjNumItems_after == ProjNumItems_before)
        {
            return;
        } else {
            var activeComp_after = app.project.activeItem.name;
            ProjectSchematicView ();
            ScV_Tree.onDoubleClick = function p_Comp ()
            {
                if (ScV_Tree.selection != null)
               {
                   if (activeComp_before == activeComp_after)
                   {
                           setParentFolder (Comp.selectedLayers[0], "Calque");
                   } else {
                       for (I=1; I<=app.project.numItems; I++)
                        {
                            if (app.project.items[I].name == app.project.activeItem.name)
                            {
                                MyNewComp = app.project.items[I];
                                setParentFolder (MyNewComp, "Compo");
                                break;
                            }
                        }
                    }
               } else return;
           SchematicView.hide();
           ScV_Tree.removeAll();
            }
            }
     app.endUndoGroup();
    }

    function renameLayersSel ()
    {
        var Comp = app.project.activeItem;
        var L_newName = PMT_renameLayers_edtx.text.toString();
        if ((L_newName == PMT_renameLayers_Txt)||(L_newName == "")) return;
        app.beginUndoGroup("[ØuTils] Renommer");
        if (Comp.selectedLayers.length == 1)
        {
            Comp.selectedLayers[0].name = L_newName;
        } else {
            for (l=0; l<Comp.selectedLayers.length; l++)
            {
                L = Comp.selectedLayers[l];
                if (L_newName.slice(L_newName.length-1, L_newName.length) == ".")
                {
                    L.name = L_newName.slice(0, L_newName.length-1);
                } else {
                    L.name = L_newName+"_"+(l+1);
                }
            }
        }
        app.endUndoGroup();
    PMT_renameLayers_edtx.text = PMT_renameLayers_Txt;
    }

    function addPrefix ()
    {
        var Comp = app.project.activeItem;
        var L_prefix = PMT_addPrefix_edtx.text.toString();
        if ((L_prefix == PMT_addPrefix_Txt)||(L_prefix == "")) return;
        app.beginUndoGroup("[ØuTils] ajouter un préfixe");
        for (l=0; l<Comp.selectedLayers.length; l++)
        {
            L = Comp.selectedLayers[l];
            if (L_prefix.slice(0,1) == "#")
            {
                L.name = (l+1)+L_prefix.slice(1, L_prefix.length)+L.name;
            } else {
                L.name = L_prefix+L.name;
            }
        }
        app.endUndoGroup();
    PMT_addPrefix_edtx.text = PMT_addPrefix_Txt;
    }

    function addSuffix ()
    {
        var Comp = app.project.activeItem;
        var L_suffix = PMT_addSuffix_edtx.text.toString();
        if ((L_suffix == PMT_addSuffix_Txt)||(L_suffix == "")) return;
        app.beginUndoGroup("[ØuTils] ajouter un suffixe");
        for (l=0; l<Comp.selectedLayers.length; l++)
        {
            L = Comp.selectedLayers[l];
            if (L_suffix.slice(L_suffix.length-1, L_suffix.length) == "#")
            {
                L.name = L.name+L_suffix.slice(0, L_suffix.length-1)+(l+1);
            } else {
                L.name = L.name+L_suffix;
            }
        }
        app.endUndoGroup();
    PMT_addSuffix_edtx.text = PMT_addSuffix_Txt;
    }

    function addMasterFolderToTree (tree)
    {
        var pFName = (app.isoLanguage == "fr_FR") ? "Premier niveau" : "Root";
        for (i=1; i<=app.project.numItems; i++)
        {
            if ((app.project.item(i).parentFolder.name != pFName)||!(app.project.item(i) instanceof FolderItem)) continue;
            newTreeNode = tree.add("node", app.project.item(i).name);
            if (AE_folderIcon.exists) newTreeNode.image = AE_folderIcon;
        }
    }

    function addSubFolderToTree (tree, folder_item)
    {
        var node_items = tree.items;
        var actualFolder = folder_item;
        
        for (i=0; i<node_items.length; i++)
        {
            var actualNode = node_items[i];
            if ((actualFolder.name == actualNode.toString())&&(actualFolder.numItems != 0))
            {
                for (foldC=1; foldC<=actualFolder.numItems; foldC++)
                {
                    var subItem = actualFolder.items[foldC];
                    if (subItem instanceof FolderItem)
                    {
                        newNode = actualNode.add("node", subItem.name);
                        if (AE_folderIcon.exists) newNode.image = AE_folderIcon;
                        //addSubFolderToTree (actualNode, subItem);
                    }
                }
                for (foldC=1; foldC<=actualFolder.numItems; foldC++)
                {
                    var subItem = actualFolder.items[foldC];
                    if (subItem instanceof FolderItem)
                    {
                        //actualNode.add("node", subItem.name);
                        addSubFolderToTree (actualNode, subItem);
                        actualNode.expanded = true;
                    }
                }
            }
        }
    }

    function ProjectSchematicView (location)
    {
        addMasterFolderToTree (ScV_Tree);

        for (f=1; f<=app.project.numItems; f++)
        {
            if (!(app.project.items[f] instanceof FolderItem)) continue ;
            addSubFolderToTree (ScV_Tree, app.project.items[f]);
        }
        if (location == "win_center")
        {
            //SchematicView.location = PMT_win.location;
            SchematicView.center(PMT_win);
        }
        SchematicView.show();
    }

    function setParentFolder (item_Obj, item_Type)
    {
        // item_Type ::: "Compo" || "Calque"
        var selec = item_Obj;
        var selecRefName = (item_Type == "Compo") ? selec.name : selec.source.name;
        //if (!isValid(selec)) return;
        
        for (i = 1; i<=app.project.numItems; i++)
        {
            if (ScV_Tree.selection.toString() == app.project.items[i].name)
            {
                ParentFolder = app.project.items[i];
                for (j=1; j<=app.project.numItems; j++)
                {
                    if (app.project.items[j] instanceof FolderItem) continue;
                    if (app.project.items[j].name == selecRefName) app.project.items[j].parentFolder = ParentFolder;
                }
            break;
            }
        }
    }

/*    function checkmarkActualParentFolder_node (tree, item_Obj, item_Type)
    {
        pf_nodes = tree.items;
        selec = item_Obj;
        selecRefName = (item_Type == "Compo") ? selec.name : selec.source.name;
        for (n=0; n<pf_nodes.length; n++)
        {
            if (pf_nodes == selecRefName) pf_nodes[n].checked = true;
            checkmarkActualParentFolder_node (pf_nodes[n], item_Obj, item_Type);
        }
    }
*/

    function isItemSel ()
    {
        var Projet = app.project;
        var isSel = false;
        for (s=1; s<=Projet.numItems; s++)
        {
            if (Projet.items[s].selected == true){ isSel = true; break};
        }
    return isSel;
    }

    function ctrlState(){
    var KeyState = ScriptUI.environment.keyboardState;
    if(KeyState.ctrlKey == true) {return 1;} else {return 0;}
    }

    function altState(){
    var KeyState = ScriptUI.environment.keyboardState;
    if(KeyState.altKey == true) {return 1;} else {return 0;}
    }
// ------------------------------------------------- fin des fonctions
// ------------------------------------------------------------------------- function's callBacks
PMT_ExecutKO_but.onClick = execute_KO;
PMT_openProjpan_but.onClick = showProjPan;
PMT_info_but.onClick = function(){alert(infoMsg_str, "Infos !")};
PMT_nItemFolderTxt_but.addEventListener("click", OrganizWithNewFolder);
PMT_Ranger_but.onClick = oRganiz;
PMT_newComp_but.onClick = newCompAndOrganiz;
PMT_preComp_but.onClick = pCompAndOrganiz;
PMT_renameLayers_edtx.onEnterKey = renameLayersSel;
PMT_addPrefix_edtx.onEnterKey = addPrefix;
PMT_addSuffix_edtx.onEnterKey = addSuffix;
}
if ((app.isoLanguage == "fr_FR")||(app.isoLanguage == "en_EN")||(app.isoLanguage == "en_US"))
{
    KeepOrganiz_PMTools (this);
} else {
    alert("Désolé mais ce script requiert qu'After Effects soit installé en Fançais ou en Anglais.\n"+
            "\n"+
            "Sorry but this script works only for French or English versions of After Effects.", "BS_Ørganiz_Øutils", errorIcon = true);
}
}